package org.dromara.shebei.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.shebei.domain.OpsSbLiebiao;
import org.dromara.shebei.mapper.OpsSbLiebiaoMapper;
import org.springframework.stereotype.Service;
import org.dromara.shebei.domain.bo.OpsSbMbBianliangBo;
import org.dromara.shebei.domain.vo.OpsSbMbBianliangVo;
import org.dromara.shebei.domain.OpsSbMbBianliang;
import org.dromara.shebei.mapper.OpsSbMbBianliangMapper;
import org.dromara.shebei.service.IOpsSbMbBianliangService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 运维-设备管理-设备模板-变量Service业务层处理
 *
 * @author LionLi
 * @date 2025-10-09
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class OpsSbMbBianliangServiceImpl extends ServiceImpl<OpsSbMbBianliangMapper, OpsSbMbBianliang> implements IOpsSbMbBianliangService {

    private final OpsSbMbBianliangMapper baseMapper;

    /**
     * 查询运维-设备管理-设备模板-变量
     *
     * @param id 主键
     * @return 运维-设备管理-设备模板-变量
     */
    @Override
    public OpsSbMbBianliangVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询运维-设备管理-设备模板-变量列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 运维-设备管理-设备模板-变量分页列表
     */
    @Override
    public TableDataInfo<OpsSbMbBianliangVo> queryPageList(OpsSbMbBianliangBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OpsSbMbBianliang> lqw = buildQueryWrapper(bo);
        Page<OpsSbMbBianliangVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的运维-设备管理-设备模板-变量列表
     *
     * @param bo 查询条件
     * @return 运维-设备管理-设备模板-变量列表
     */
    @Override
    public List<OpsSbMbBianliangVo> queryList(OpsSbMbBianliangBo bo) {
        LambdaQueryWrapper<OpsSbMbBianliang> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OpsSbMbBianliang> buildQueryWrapper(OpsSbMbBianliangBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OpsSbMbBianliang> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(OpsSbMbBianliang::getId);
        lqw.eq(bo.getMbId() != null, OpsSbMbBianliang::getMbId, bo.getMbId());
        lqw.like(StringUtils.isNotBlank(bo.getBlName()), OpsSbMbBianliang::getBlName, bo.getBlName());
        lqw.eq(StringUtils.isNotBlank(bo.getBlDanwei()), OpsSbMbBianliang::getBlDanwei, bo.getBlDanwei());
        lqw.eq(StringUtils.isNotBlank(bo.getBlBiaoshifu()), OpsSbMbBianliang::getBlBiaoshifu, bo.getBlBiaoshifu());
        lqw.eq(StringUtils.isNotBlank(bo.getBlType()), OpsSbMbBianliang::getBlType, bo.getBlType());
        lqw.eq(StringUtils.isNotBlank(bo.getJicunqiGnm()), OpsSbMbBianliang::getJicunqiGnm, bo.getJicunqiGnm());
        lqw.eq(StringUtils.isNotBlank(bo.getJicunqiAdd()), OpsSbMbBianliang::getJicunqiAdd, bo.getJicunqiAdd());
        lqw.eq(StringUtils.isNotBlank(bo.getShujvGeshi()), OpsSbMbBianliang::getShujvGeshi, bo.getShujvGeshi());
        lqw.eq(StringUtils.isNotBlank(bo.getCaijiPinlu()), OpsSbMbBianliang::getCaijiPinlu, bo.getCaijiPinlu());
        lqw.eq(StringUtils.isNotBlank(bo.getShuziGeshi()), OpsSbMbBianliang::getShuziGeshi, bo.getShuziGeshi());
        lqw.eq(StringUtils.isNotBlank(bo.getCunchuFangshi()), OpsSbMbBianliang::getCunchuFangshi, bo.getCunchuFangshi());
        lqw.eq(StringUtils.isNotBlank(bo.getDuxieFangshi()), OpsSbMbBianliang::getDuxieFangshi, bo.getDuxieFangshi());
        return lqw;
    }

    /**
     * 新增运维-设备管理-设备模板-变量
     *
     * @param bo 运维-设备管理-设备模板-变量
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(OpsSbMbBianliangBo bo) {
        OpsSbMbBianliang add = MapstructUtils.convert(bo, OpsSbMbBianliang.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改运维-设备管理-设备模板-变量
     *
     * @param bo 运维-设备管理-设备模板-变量
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(OpsSbMbBianliangBo bo) {
        OpsSbMbBianliang update = MapstructUtils.convert(bo, OpsSbMbBianliang.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OpsSbMbBianliang entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除运维-设备管理-设备模板-变量信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
